题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6205
Time Limit: 8000/4000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Problem Description

As a fan of Doudizhu, WYJ likes collecting playing cards very much. 
One day, MJF takes a stack of cards and talks to him: let's play a game and if you win, you can get all these cards. MJF randomly assigns these cards into n heaps, arranges in a row, and sets a value on each heap, which is called "penalty value".
Before the game starts, WYJ can move the foremost heap to the end any times. 
After that, WYJ takes the heap of cards one by one, each time he needs to move all cards of the current heap to his hands and face them up, then he turns over some cards and the number of cards he turned is equal to the penalty value.
If at one moment, the number of cards he holds which are face-up is less than the penalty value, then the game ends. And WYJ can get all the cards in his hands (both face-up and face-down).
Your task is to help WYJ maximize the number of cards he can get in the end.So he needs to decide how many heaps that he should move to the end before the game starts. Can you help him find the answer?
MJF also guarantees that the sum of all "penalty value" is exactly equal to the number of all cards.

Input

There are about 10 test cases ending up with EOF.
For each test case:
the first line is an integer n (1\leq n\leq 10^6), denoting n heaps of cards;
next line contains n integers, the ith integer a_i (0\leq ai\leq 1000) denoting there are a_i cards in ithheap;
then the third line also contains n integers, the ith integer b_i (1\leq bi\leq 1000) denoting the "penalty value" of ith heap is b_i.

Output

For each test case, print only an integer, denoting the number of piles WYJ needs to move before the game starts. If there are multiple solutions, print the smallest one.

Sample Input

5
4 6 2 8 4
1 5 7 9 2

Sample Output

4

Hint

For the sample input:

+ If WYJ doesn't move the cards pile, when the game starts the state of cards is:
    4 6 2 8 4
    1 5 7 9 2
WYJ can take the first three piles of cards, and during the process, the number of face-up cards is 4-1+6-5+2-7. Then he can't pay the the "penalty value" of the third pile, the game ends. WYJ will get 12 cards.
+ If WYJ move the first four piles of cards to the end, when the game starts the state of cards is:
    4 4 6 2 8
    2 1 5 7 9
WYJ can take all the five piles of cards, and during the process, the number of face-up cards is 4-2+4-1+6-5+2-7+8-9. Then he takes all cards, the game ends. WYJ will get 24 cards.

It can be improved that the answer is 4.

**huge input, please use fastIO.**

Problem solving report:

Description: 求通过把最前面的一堆牌翻转到最后满足能把所有的牌的数目都取到的最少反转次数。
Problem solving: 根据题意,牌的数量和消耗的费用是相同的,所以总有一种顺序能够取到所有的牌。

我们首先从顺序头开始扫描求和,记为ans,出现ans为负的情况时做一个标记,然后ans重置为0,ans出现了负数,那么当前下标之前到上次出现负数的位置之间的所有数字都应该移动一次(即移动i-k次,更新k),继续向后扫描,重复上面的过程。求出移动的次数之和就行了。

我们假设ai~bi这一段为负数,那么(bi-ai)就是最后ans为负数的位置,所以我们只要统计出ans最后一次出现负数的位置就行了。

Accepted Code:

/* 
 * @Author: lzyws739307453 
 * @Language: C++ 
 */
#include <bits/stdc++.h>
using namespace std;
const int MAXN = 1e6 + 5;
int spt[MAXN];
int main() {
    int n, k, ans, num;
    while (~scanf("%d", &n)) {
        for (int i = 1; i <= n; i++)
            scanf("%d", &spt[i]);
        for (int i = 1; i <= n; i++) {
            scanf("%d", &num);
            spt[i] -= num;
        }
        ans = 0, k = 0;
        for (int i = 1; i <= n; i++) {
            ans += spt[i];
            if (ans < 0) {
                k = i;
                ans = 0;
            }
        }
        printf("%d\n", k);
    }
    return 0;
}